---
title: 'HTML attribute: accept'
slug: Web/HTML/Attributes/accept
tags:
  - Accept
  - Attribute
  - File
  - HTML
  - Input
  - Reference
---
<p>{{HTMLSidebar}}</p>

<p class="summary"><span class="seoSummary">The <strong><code>accept</code></strong> attribute takes as its value a comma-separated list of one or more file types, or {{anch("Unique file type specifiers", "unique file type specifiers")}}, describing which file types to allow. </span>The accept property is an attribute of the {{HTMLElement("input/file", "file")}} {{htmlelement("input")}} type. It was supported on the {{htmlelement("form")}} element, but was removed in favor of {{HTMLElement("input/file", "file")}} in HTML5.</p>

<p>Because a given file type may be identified in more than one manner, it's useful to provide a thorough set of type specifiers when you need files of specific type, or use the wild card to denote a type of any format is acceptable.</p>

<p>For instance, there are a number of ways Microsoft Word files can be identified, so a site that accepts Word files might use an <code>&lt;input&gt;</code> like this:</p>

<pre class="brush: html notranslate">&lt;input type="file" id="docpicker"
  accept=".doc,.docx,application/msword,application/vnd.openxmlformats-officedocument.wordprocessingml.document"&gt;</pre>

<p>Whereas if you're accepting a media file, you may want to be include any format of that media type:</p>

<pre class="brush: html notranslate">&lt;input type="file" id="soundFile" accept="audio/*"&gt;
&lt;input type="file" id="videoFile" accept="video/*"&gt;
&lt;input type="file" id="imageFile" accept="image/*"&gt;</pre>

<p>The <code>accept</code> attribute doesn't validate the types of the selected files; it provides hints for browsers to guide users towards selecting the correct file types. It is still possible (in most cases) for users to toggle an option in the file chooser that makes it possible to override this and select any file they wish, and then choose incorrect file types.</p>

<p>Because of this, you should make sure that expected requirement is validated server-side.</p>

<h2 id="Examples">Examples</h2>

<p>When set on a file input type, the native file picker that opens up should only enable selecting files of the correct file type. Most operating systems lighten the files that don't match the criteria and aren't selectable.</p>

<div id="simple_example">
<pre class="brush: html notranslate">&lt;p&gt;
	&lt;label for="soundFile"&gt;Select an audio file:&lt;/label&gt;
	&lt;input type="file" id="soundFile" accept="audio/*"&gt;
	&lt;/p&gt;
	&lt;p&gt;
	&lt;label for="videoFile"&gt;Select a video file:&lt;/label&gt;
	&lt;input type="file" id="videoFile" accept="video/*"&gt;
	&lt;/p&gt;
	&lt;p&gt;
	&lt;label for="imageFile"&gt;Select some images:&lt;/label&gt;
	&lt;input type="file" id="imageFile" accept="image/*" multiple&gt;
	&lt;/p&gt;</pre>

<p>{{EmbedLiveSample('simple_example', '100%', 200)}}</p>

<p>Note the last example allows you to select multiple images. See the <code><a href="multiple">multiple</a></code> attribute for more information.</p>
</div>

<h2 id="Unique_file_type_specifiers">Unique file type specifiers</h2>

<p>A <strong>unique file type specifier</strong> is a string that describes a type of file that may be selected by the user in an {{HTMLElement("input")}} element of type <code>file</code>. Each unique file type specifier may take one of the following forms:</p>

<ul>
 <li>A valid case-insensitive filename extension, starting with a period (".") character. For example: <code>.jpg</code>, <code>.pdf</code>, or <code>.doc</code>.</li>
 <li>A valid MIME type string, with no extensions.</li>
 <li>The string <code>audio/*</code> meaning "any audio file".</li>
 <li>The string <code>video/*</code> meaning "any video file".</li>
 <li>The string <code>image/*</code> meaning "any image file".</li>
</ul>

<p>The <code>accept</code> attribute takes as its value a string containing one or more of these unique file type specifiers, separated by commas. For example, a file picker that needs content that can be presented as an image, including both standard image formats and PDF files, might look like this:</p>

<pre class="brush: html notranslate">&lt;input type="file" accept="image/*,.pdf"&gt;</pre>

<h2 id="Using_file_inputs">Using file inputs</h2>

<h3 id="A_basic_example">A basic example</h3>

<pre class="brush: html notranslate">&lt;form method="post" enctype="multipart/form-data"&gt;
 &lt;div&gt;
   &lt;label for="file"&gt;Choose file to upload&lt;/label&gt;
   &lt;input type="file" id="file" name="file" multiple&gt;
 &lt;/div&gt;
 &lt;div&gt;
   &lt;button&gt;Submit&lt;/button&gt;
 &lt;/div&gt;
&lt;/form&gt;</pre>

<div class="hidden">
<pre class="brush: css notranslate">div {
  margin-bottom: 10px;
}</pre>
</div>

<p>This produces the following output:</p>

<p>{{EmbedLiveSample('A_basic_example', 650, 60)}}</p>

<div class="note">
<p><strong>Note</strong>: You can find this example on GitHub too — see the <a href="https://github.com/mdn/learning-area/blob/master/html/forms/file-examples/simple-file.html">source code</a>, and also <a href="https://mdn.github.io/learning-area/html/forms/file-examples/simple-file.html">see it running live</a>.</p>
</div>

<p>Regardless of the user's device or operating system, the file input provides a button that opens up a file picker dialog that allows the user to choose a file.</p>

<p>Including the <code><a href="multiple">multiple</a></code> attribute, as shown above, specifies that multiple files can be chosen at once. The user can choose multiple files from the file picker in any way that their chosen platform allows (e.g. by holding down <kbd>Shift</kbd> or <kbd>Control</kbd>, and then clicking). If you only want the user to choose a single file per <code>&lt;input&gt;</code>, omit the <code>multiple</code> attribute.</p>

<h3 id="Limiting_accepted_file_types">Limiting accepted file types</h3>

<p>Often you won't want the user to be able to pick any arbitrary type of file; instead, you often want them to select files of a specific type or types. For example, if your file input lets users upload a profile picture, you probably want them to select web-compatible image formats, such as {{Glossary("JPEG")}} or {{Glossary("PNG")}}.</p>

<p>Acceptable file types can be specified with the {{htmlattrxref("accept","input/file")}} attribute, which takes a comma-separated list of allowed file extensions or MIME types. Some examples:</p>

<ul>
 <li><code>accept="image/png"</code> or <code>accept=".png"</code> — Accepts PNG files.</li>
 <li><code>accept="image/png, image/jpeg"</code> or <code>accept=".png, .jpg, .jpeg"</code> — Accept PNG or JPEG files.</li>
 <li><code>accept="image/*"</code> — Accept any file with an <code>image/*</code> MIME type. (Many mobile devices also let the user take a picture with the camera when this is used.)</li>
 <li><code>accept=".doc,.docx,.xml,application/msword,application/vnd.openxmlformats-officedocument.wordprocessingml.document"</code> — accept anything that smells like an MS Word document.</li>
</ul>

<p>Let's look at a more complete example:</p>

<pre class="brush: html notranslate">&lt;form method="post" enctype="multipart/form-data"&gt;
  &lt;div&gt;
    &lt;label for="profile_pic"&gt;Choose file to upload&lt;/label&gt;
    &lt;input type="file" id="profile_pic" name="profile_pic"
          accept=".jpg, .jpeg, .png"&gt;
  &lt;/div&gt;
  &lt;div&gt;
    &lt;button&gt;Submit&lt;/button&gt;
  &lt;/div&gt;
&lt;/form&gt;</pre>

<div class="hidden">
<pre class="brush: css notranslate">div {
  margin-bottom: 10px;
}</pre>
</div>

<p>{{EmbedLiveSample('Limiting_accepted_file_types', 650, 60)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'input.html#attr-input-accept', 'accept attribute')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', 'sec-forms.html#attr-input-accept', 'accept attribute')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.attribute.accept")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Using_files_from_web_applications">Using files from web applications</a></li>
 <li><a href="/en-US/docs/Web/API/File">File API</a></li>
</ul>
